<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { CONTENT_TYPES } from '../../common/content-types';
import { partnerIndexService } from '../../services/partners/partner-index.service';

import { GetStartedResources } from '~/components/get-started/index.vue';
import {
  CTA as CallToAction,
  Benefits,
  FreeTrialCTA,
  NextStep,
} from '~/components/common/index.vue';
import {
  Carousel as QuotesCarousel,
  FeaturedPartners,
  PartnersShowcase,
  PartnersIntro as Intro,
  PartnersCopyBlock as CopyBlock,
  PartnersResources as Resources,
  PartnersHero as Hero,
} from '~/components/partners/index.vue';
import { getPageMetadata } from '~/common/meta';
import { getClient } from '~/plugins/contentful.js';

export default Vue.extend({
  components: {
    CallToAction,
    FeaturedPartners,
    Benefits,
    FreeTrialCTA,
    Intro,
    QuotesCarousel,
    Hero,
    CopyBlock,
    GetStartedResources,
    NextStep,
    PartnersShowcase,
    Resources,
  },
  // eslint-disable-next-line
  async asyncData({ $content, i18n, error }: any) {
    try {
      const locale = i18n.locale === i18n.defaultLocale ? '' : i18n.locale;
      let partner;

      if (i18n.locale !== 'en-us') {
        partner = await $content(locale, 'partners/index').fetch();
        return { partner };
      }
      const response = await getClient().getEntries({
        content_type: CONTENT_TYPES.PAGE,
        'fields.slug': 'partners',
        include: 10,
      });

      const { pageContent } = response.items[0].fields;
      const seoMetadata = response.items[0].fields.seoMetadata[0].fields;

      partner = partnerIndexService(pageContent);

      const metadata = {
        title: seoMetadata.title,
        description: seoMetadata.description,
        og_title: seoMetadata.title,
        og_description: seoMetadata.description,
      };
      return { partner, metadata };
    } catch (e) {
      error({ statusCode: 404 });
      return {};
    }
  },

  head(): MetaInfo {
    if (this.metadata) {
      return getPageMetadata(
        (this as any).metadata,
        this.$route.path,
        this.$nuxtI18nHead({ addSeoAttributes: true }),
      );
    }
    return getPageMetadata(
      (this as any).partner,
      this.$route.path,
      this.$nuxtI18nHead({ addSeoAttributes: true }),
    );
  },
});
</script>

<template>
  <section class="partners-container">
    <component
      :is="component.name"
      v-for="(component, index) in partner.components"
      :key="component.name + index"
      :data="component.data"
    />
    <SlpContainer variant="gradient">
      <NextStep :variant="partner.next_steps_variant" />
    </SlpContainer>
  </section>
</template>

<style lang="scss" scoped>
.partners-container {
  overflow-x: hidden;
}
</style>
